<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright  2015 Jim Dudek AKA Nhawk/Snog                        # ||
|| # All Rights Reserved.                                             # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this file on your server unless       # ||
|| # you have purchased OSBrowser Display from snogssite.com.         # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

class Snog_OSBrowser_DataWriter_ConversationMessage extends XFCP_Snog_OSBrowser_DataWriter_ConversationMessage
{
	protected function _getFields()
	{
		$fields = parent::_getFields();
		$fields['xf_conversation_message']['useragent_browser'] = array('type' => self::TYPE_STRING);
		$fields['xf_conversation_message']['useragent_browser_icon'] = array('type' => self::TYPE_STRING);
		$fields['xf_conversation_message']['useragent_os'] = array('type' => self::TYPE_STRING);
		$fields['xf_conversation_message']['useragent_os_icon'] = array('type' => self::TYPE_STRING);
		return $fields;
	}

	protected function _preSave()
	{
		$user_agent = 'unknown';
		$response = '';
		if(isset($_SERVER['HTTP_USER_AGENT'])) $user_agent = $_SERVER['HTTP_USER_AGENT'];
		$final = array();
		$final['useragent_browser'] = 'unknown';
		$final['useragent_browser_icon'] = 'unknown.png';
		$final['useragent_os'] = 'unknown';
		$final['useragent_os_icon'] = 'unknown.png';
		$browser_id = $os_id = null;
		$ua_info = parse_ini_file('data/osbrowser/uasdata.ini', true);

		// OS-BROWSER
		foreach ($ua_info['browser_reg'] as $info) 
		{
			if(@preg_match($info[0], $user_agent, $match)) 
			{
				$browser_id = $info[1];
				if(isset($ua_info['browser'][$browser_id])) 
				{
					$browser_data = $ua_info['browser'][$browser_id];
					if($browser_data[1]) $final['useragent_browser'] = $browser_data[1] . (isset($match[1]) ? ' ' . $match[1] : '');
					if($browser_data[5]) $final['useragent_browser_icon'] = $browser_data[5];
				}
				if(isset($ua_info['browser_os'][$browser_id])) 
				{
					$os_id = $ua_info['browser_os'][$browser_id][0];
					$os_data = $ua_info['os'][$os_id];
					if($os_data[1]) $final['useragent_os'] = $os_data[1];
					if($os_data[5]) $final['useragent_os_icon'] = $os_data[5];
				}
				break;
			}
		}

		if(!$os_id) 
		{
			foreach ($ua_info['os_reg'] as $info)
			{
				if(@preg_match($info[0], $user_agent))
				{
					$os_id = $info[1];
					if(isset($ua_info['os'][$os_id]))
					{
						$os_data = $ua_info['os'][$os_id];
						if($os_data[1]) $final['useragent_os'] = $os_data[1];
						if($os_data[5]) $final['useragent_os_icon'] = $os_data[5];
					}
					break;
				}
			}
		}

		if($final['useragent_browser'] == 'unknown' || $final['useragent_os'] == 'unknown')
		{
			if(stristr($user_agent,'Tapatalk'))
			{
				$this->set('useragent_browser', 'Tapatalk');
				$this->set('useragent_browser_icon', 'class="tapatalk"');
				$this->set('useragent_os', 'Unknown Mobile');
				$this->set('useragent_os_icon', 'class="mobile"');
			}else{
				if($final['useragent_browser'] == 'unknown')
				{
					$this->set('useragent_browser', 'Unknown');
					$this->set('useragent_browser_icon', 'class="unknown"');
					if(XenForo_Application::getOptions()->snog_osbrowser_log)
					{
						$filename = 'data/osbrowser/unknown_agent.log';
						$content = 'Unknown Browser: ' . $user_agent . "\r\n";
						$handle = fopen($filename, 'a');
						fwrite($handle, $content);
						fclose($handle);
					}
				}else{
					$this->set('useragent_browser', $final['useragent_browser']);
					$file_check = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$final['useragent_browser_icon']);
					$file_check = trim($file_check);
					$path = 'data/osbrowser/icons/' . $file_check;
					if(!file_exists($path))
					{
						$this->set('useragent_browser_icon', 'unknown.png');
					}else{
						$classname = strtolower($final['useragent_browser_icon']);
						$classname = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$classname);
						$classname = preg_replace('/(_| |\.)/','-',$classname);
						$this->set('useragent_browser_icon', 'class="' . $classname . '"');
					}
				}
				if($final['useragent_os'] == 'unknown')
				{
					$this->set('useragent_os', 'Unknown');
					$this->set('useragent_os_icon', 'class="unknown"');
					if(XenForo_Application::getOptions()->snog_osbrowser_log)
					{
						$filename = 'data/osbrowser/unknown_agent.log';
						$content = 'Unknown OS: ' . $user_agent . "\r\n";
						$handle = fopen($filename, 'a');
						fwrite($handle, $content);
						fclose($handle);
					}
				}else{
					$this->set('useragent_os', $final['useragent_os']);
					$file_check = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$final['useragent_os_icon']);
					$file_check = trim($file_check);
					$path = 'data/osbrowser/icons/' . $file_check;
					if(!file_exists($path))
					{
						$this->set('useragent_os_icon', 'unknown.png');
					}else{
						$classname = strtolower($final['useragent_os_icon']);
						$classname = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$classname);
						$classname = preg_replace('/(_| |\.)/','-',$classname);
						$this->set('useragent_os_icon', 'class="' . $classname . '"');
					}
				}
			}
		}else{
			$this->set('useragent_browser', $final['useragent_browser']);
			$this->set('useragent_os', $final['useragent_os']);
			$file_check = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$final['useragent_browser_icon']);
			$file_check = trim($file_check);
			$path = 'data/osbrowser/icons/' . $file_check;
			if(!file_exists($path))
			{
				$this->set('useragent_browser_icon', 'unknown.png');
			}else{
				$classname = strtolower($final['useragent_browser_icon']);
				$classname = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$classname);
				$classname = preg_replace('/(_| |\.)/','-',$classname);
				$this->set('useragent_browser_icon', 'class="' . $classname . '"');
			}
			$file_check = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$final['useragent_os_icon']);
			$file_check = trim($file_check);
			$path = 'data/osbrowser/icons/' . $file_check;
			if(!file_exists($path))
			{
				$this->set('useragent_os_icon', 'unknown.png');
			}else{
				$classname = strtolower($final['useragent_os_icon']);
				$classname = preg_replace('/(\.png|\.gif|\.jpg|\.com)/','',$classname);
				$classname = preg_replace('/(_| |\.)/','-',$classname);
				$this->set('useragent_os_icon', 'class="' . $classname . '"');
			}
		}
		parent::_preSave();
	}
}
